--- ircd-hybrid-7beta15.orig/src/ircd.c	Wed May  8 04:54:02 2002
+++ ircd-hybrid-7beta15/src/ircd.c	Fri May 24 18:49:09 2002
@@ -560,13 +560,22 @@
 
 int main(int argc, char *argv[])
 {
-  /* Check to see if the user is running us as root, which is a nono */
   
-  if(geteuid() == 0)
-  {
-    fprintf(stderr, "Don't run ircd as root!!!\n");
-    return -1;
-  }
+#ifndef IRC_UID
+	/* Check to see if the user is running us as root, which is a nono */
+	if(geteuid() == 0) 
+	{
+		fprintf(stderr, "ERROR: Don't run ircd as root!\n");
+		return -1;
+	}
+#endif
+#if defined(IRC_UID) && defined(IRC_GID)
+	if(geteuid() == 0)
+	{
+		setgid(IRC_GID);
+		setuid(IRC_UID);
+	}
+#endif
 
   /*
    * save server boot time right away, so getrusage works correctly
